package cn.ibizlab.core.sample.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.sample.domain.IBIZStorage;
import cn.ibizlab.core.sample.filter.IBIZStorageSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[IBIZStorage] 服务对象接口
 */
public interface IIBIZStorageService extends IService<IBIZStorage> {

    boolean create(IBIZStorage et);
    void createBatch(List<IBIZStorage> list);
    boolean update(IBIZStorage et);
    void updateBatch(List<IBIZStorage> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    IBIZStorage get(String key);
    IBIZStorage getDraft(IBIZStorage et);
    boolean checkKey(IBIZStorage et);
    boolean save(IBIZStorage et);
    void saveBatch(List<IBIZStorage> list);
    Page<IBIZStorage> searchDefault(IBIZStorageSearchContext context);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<IBIZStorage> getIbizstorageByIds(List<String> ids);
    List<IBIZStorage> getIbizstorageByEntities(List<IBIZStorage> entities);
}


